var logger = require('trucktrack-logging').logger;
var ignored = require('trucktrack-ignored');

module.exports = function(req, res, config, next) {
  if (!config) {
    next(new Error('Configuration argument is missing.'));
  }

  var http = new(require('./http'))(config.tokenEndpoint);
  if (ignored(req, config)) {
    next();
    return;
  }
  var auth = req.header('Authorization');
  if (auth) {
    http.checkToken(auth.slice(7), function(err, response) {
      if (err) {
        logger.warn("Token is not valid", req.body);
        res.status(401).end();
        return;
      } else {
        next();
      }
    });
  } else {
    logger.warn("Token is not valid", req.body);

    res.status(401).end();
    return;
  }
};
