var request = require('request');
var getNamespace = require('continuation-local-storage').getNamespace;

function TokenUtil(url) {
  this.url = url;
}

TokenUtil.prototype.checkToken = function(token, callback) {
  var session = getNamespace('oauth');
  session.set('token', token);
  request({
    url: this.url,
    method: "POST",
    json: true,
    body: {
      token: token
    }
  }, function(error, response, body) {
    if (error) {
      callback(error);
      return;
    }
    if (response.statusCode === 200 && body) {
      callback(null, body);
    } else {
      callback("Invalid token.");
    }
  });


};

module.exports = TokenUtil;
