var proxyquire = require('proxyquire');
var nock = require('nock');
var chai = require('chai'),
  spies = require('chai-spies');
chai.use(spies);
var expect = chai.expect;
var logger = require('trucktrack-logging').logger;

describe("http", function() {
  it("should get a namespace", function(done) {
    var getSpy = chai.spy(function(next) {
    });
    var setSpy = chai.spy(function(key, value) {
    });
    var http = new (proxyquire('../lib/http', {
      'continuation-local-storage': {
        getNamespace: function(namespace) {
          getSpy(namespace);
          return {
            set: function(key, value) {
              setSpy(key, value);
            }
          }
        }
      }
    }))('http://localhost:8080/auth/check_token');

    nock('http://localhost:8080').get('/api/file/1').replyWithError(200, {id: '42', base64: 'content'});
    http.checkToken('token123', function () {

      expect(getSpy).to.have.been.called();
      logger.info('Done');
      expect(setSpy).to.have.been.called.with('token', 'token123');
      done();
    });

  });
});
